<!DOCTYPE html>
<html lang="en">
<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
    <!-- Popper Development version -->
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import DataTable Library -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <!-- Import Datatable sau jquery -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  
</head>
<body>  
    <div class="container mt-4">
        <h3 class="text-center">Lucky Dice History</h3><br>
        <div class="row jumbotron p-3 m-0">
            <div class="col-sm-12">
                <form action="">
                    <div class="form-row">
                        <h5>Thông tin người chơi</h5>
                    </div>
                    <div class="form-row">
                       <div class="form-group col-md-4">
                        <label for="">Username</label>
                        <input type="text" class="form-control bg-secondary text-white" id="inp-username" disabled>
                       </div>
                       <div class="form-group col-md-4">
                        <label for="">Firstname</label>
                        <input type="text" class="form-control bg-secondary text-white" id="inp-firstname" disabled>
                       </div>
                       <div class="form-group col-md-4">
                        <label for="">Lastname</label>
                        <input type="text" class="form-control bg-secondary text-white" id="inp-lastname" disabled>
                       </div>
                    </div>
                </form>
            </div>
          </div>
        <table id="user-table" class="table table-striped table-bordered table-hover">
            <thead>
                <tr>
                    <th>STT</th>
                    <th>Kết quả</th>  
                </tr>
            </thead>
        </table>  
      </div>
</body>
<script>
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/"
        const gSTT = 1;
        const gSTT_COL = 0;
        const gDICE = 1
        const gHistoryData = []
        const gDICE_COL = ["stt","dice"];
        const gDataTable = $("#user-table").DataTable({
         columns:[
          {data:gDICE_COL[0]},
         {data:gDICE_COL[1]},
        
         ],
         columnDefs:[
         {
        targets: gSTT_COL, //cột STT
        className: "text-center text-primary",
        render: function (data, type, row, meta) {
          return meta.row + meta.settings._iDisplayStart + 1;
          }
         },
             { targets:gDICE,
               className:"text-center text-success"
             }  
        ]
    });
    const gUserUrl = {
        username:"",
        firstname:"",
        lastname:""
    }
    $(document).ready(function() {
     
        onPageLoading()
        catchDataFromUrl(vCurrentUrl)
        console.log(gUserUrl)
    })
      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        function onBtnHistoryClick() {
          
        }
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ 

    //on load
   function onPageLoading(){
    var vCurrentUrl = window.location.href
    catchDataFromUrl(vCurrentUrl)
        console.log(gUserUrl)
    getApiLuckyDice(gUserUrl.username)
    laodDataInp(gUserUrl)
   }
   //get api lucky dice
   function getApiLuckyDice(pramUserName) {
    $.ajax({
        url: "http://203.171.20.210:8080/devcamp-lucky-dice/"+ "/dice-history?username="+ pramUserName,
        async:false,
        type: "GET",
        success:function(data){
            console.log(data)
            if(data.dices.length >0){
                var vCount = 0
                while(vCount < data.dices.length){
                    var bDice = {"game":vCount,"dice":data.dices[vCount]}
                    console.log(bDice)
                    gHistoryData.push(bDice)
                    vCount++
                }
             loadDataTableUser(gHistoryData)
            }
        },
        error: function(ajaxContext){
            alert(ajaxContext.responseText)
        }
    });
   }
   function loadDataTableUser(paramDiceArray){
    gDataTable.clear();
    gDataTable.rows.add(paramDiceArray);
    gDataTable.draw();
   }
   // this is event querystring info url 
   function catchDataFromUrl(paramCurrenUrl) {
    var vNewUrl = new URL(paramCurrenUrl);
    gUserUrl.username = vNewUrl.searchParams.get("username");
    gUserUrl.firstname = vNewUrl.searchParams.get("firstname");
    gUserUrl.lastname = vNewUrl.searchParams.get("lastname");
   }
   //this is laod data inp
   function laodDataInp(paramUserUrl) {
     $("#inp-username").val(paramUserUrl.username);
     $("#inp-firstname").val(paramUserUrl.firstname);
     $("#inp-lastname").val(paramUserUrl.lastname);
   }
</script>
</html>